From fc8db55d4a3ecefd2f749fa0b3ad0f07498b1f3f Mon Sep 17 00:00:00 2001
From: grizzlyuser <grizzlyuser@protonmail.com>
Date: Jan 05 2021 14:18:39 +0000
Subject: [PATCH 4/8] libre/iceweasel: process icons for top sites


Remove bundled icons of all websites except Wikipedia. Generate icons
and thumbnails for top sites configured by Parabola from SVG sources
from the branding package.

They need to be displayed on new tab. If not added, thumbnails will be
automatically generated for each website by completely loading it in
background and making a screenshot at start of each browser session.
This network communication can be unwanted for those on pay-per-byte
data plans.

---

diff --git a/libre/iceweasel/PKGBUILD b/libre/iceweasel/PKGBUILD
index 5d40e11..450c986 100644
--- a/libre/iceweasel/PKGBUILD
+++ b/libre/iceweasel/PKGBUILD
@@ -257,6 +257,27 @@ END
       -o "${brandingdestdir}/default$i.png"
   done
 
+  # process default Top Sites and their icons
+  local tippytopdir=browser/components/newtab/data/content/tippytop
+  find "${tippytopdir}" -type f \
+    -not -name 'wikipedia-org*' \
+    -not -name 'top_sites.json' \
+    -exec rm -v {} \;
+  for image in "${brandingsrcdir}"/tippytop/*.svg; do
+    local outname=$(basename -s .svg "${image}")
+
+    local size=$(identify -format '%wx%h' "${tippytopdir}"/images/wikipedia-org@2x.png)
+    magick -density 300 $image -gravity center -resize $size -extent $size \
+      "${tippytopdir}/images/${outname}@2x.png"
+
+    local background='none'
+    if [[ $outname == 'gnu' ]]; then background='white'; fi
+    size=256x256
+    magick -density 300 -background $background $image -gravity center \
+      -resize $size -extent $size -define icon:auto-resize=64,48,32,16 \
+      "${tippytopdir}/favicons/${outname}.ico"
+  done
+
   # apply branding patches
   export QUILT_PATCHES="${brandingsrcdir}"/patches
   export QUILT_REFRESH_ARGS='-p ab --no-timestamps --no-index'

